
#property copyright "Copyright  2011, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_chart_window

extern int ShowFibs = 1;
extern int LargeLineExtension = 20;
extern double LargeDeviation = 0.75;
extern int LargeLineWidth = 3;
extern int MediumLineExtension = 30;
extern double MediumDeviation = 0.5;
extern int MediumLineWidth = 2;
extern int SmallLineExtension = 30;
extern double SmallDeviation = 0.75;
extern int SmallLineWidth = 1;
int gi_128 = -1;
int gi_132 = -1;
double g_high_136 = 0.0;
double g_low_144 = 0.0;
int gi_152 = -1;
int gi_156 = -1;
double g_high_160 = 0.0;
double g_low_168 = 0.0;
int gi_176 = -1;
int gi_180 = -1;
double g_low_184 = 0.0;
double g_low_192 = 0.0;

int init() {
   return (0);
}

int deinit() {
//   ObjectsDeleteAll(0);
   string name_0;
   int objs_total_8 = ObjectsTotal();
   for (int li_12 = objs_total_8 - 1; li_12 >= 0; li_12--) {
      name_0 = ObjectName(li_12);
      if (StringSubstr(name_0, 0, 1) == "A" || StringSubstr(name_0, 0, 1) == "B" ||
         StringSubstr(name_0, 0, 1) == "C") ObjectDelete(name_0);
   }
   return (0);
}

int start() {
   int li_24;
   int li_28;
   int l_ind_counted_0 = IndicatorCounted();
   int li_4 = Bars - l_ind_counted_0;

   for (int li_20 = li_4; li_20 >= 0; li_20--) {
      li_24 = ZigZagHigh(Symbol(), Period(), LargeDeviation, 1, 150, li_20);
      li_28 = ZigZagLow(Symbol(), Period(), LargeDeviation, 1, 150, li_20);
      if (li_24 == li_20 + 1) {
         g_high_136 = High[li_24];
         CalculateHighPivot("A", gi_132, gi_128, g_high_136, g_low_144, LargeLineWidth, LargeLineExtension, li_20);
      }
      if (li_28 == li_20 + 1) {
         g_low_144 = Low[li_28];
         CalculateLowPivot("A", gi_132, gi_128, g_high_136, g_low_144, LargeLineWidth, LargeLineExtension, li_20);
      }
      li_24 = ZigZagHigh(Symbol(), Period(), MediumDeviation, 1, 100, li_20);
      li_28 = ZigZagLow(Symbol(), Period(), MediumDeviation, 1, 100, li_20);
      if (li_24 == li_20 + 1) {
         g_high_160 = High[li_24];
         CalculateHighPivot("B", gi_156, gi_152, g_high_160, g_low_168, MediumLineWidth, MediumLineExtension, li_20);
      }
      if (li_28 == li_20 + 1) {
         g_low_168 = Low[li_28];
         CalculateLowPivot("B", gi_156, gi_152, g_high_160, g_low_168, MediumLineWidth, MediumLineExtension, li_20);
      }
      li_24 = ZigZagHigh(Symbol(), Period(), SmallDeviation, 1, 60, li_20);
      li_28 = ZigZagLow(Symbol(), Period(), SmallDeviation, 1, 60, li_20);
      if (li_24 == li_20 + 1) {
         g_low_184 = Low[li_24];
         CalculateHighPivot("C", gi_180, gi_176, g_low_184, g_low_192, SmallLineWidth, SmallLineExtension, li_20);
      }
      if (li_28 == li_20 + 1) {
         g_low_192 = Low[li_28];
         CalculateLowPivot("C", gi_180, gi_176, g_low_184, g_low_192, SmallLineWidth, SmallLineExtension, li_20);
      }
   }
   return (0);
}

int ZigZagHigh(string a_symbol_0, int a_timeframe_8, int ai_12, int ai_16, int ai_20, int ai_24) {
   int li_ret_28 = ai_24;
   double l_ihigh_32 = 0;
   double l_icustom_40 = 0;
   int li_48 = 1;
   while (true) {
      if (li_ret_28 >= ai_24 + ai_20) break;
      l_icustom_40 = iCustom(a_symbol_0, a_timeframe_8, "ZigZag", 12, ai_12, 3, 0, li_ret_28);
      l_ihigh_32 = iHigh(a_symbol_0, a_timeframe_8, li_ret_28);
      if (!(l_icustom_40 == 0.0 || l_icustom_40 == EMPTY_VALUE) && !(l_icustom_40 == -1.0)) {
         if (l_ihigh_32 > 0.0 && l_icustom_40 > 0.0 && l_icustom_40 >= l_ihigh_32) {
            if (li_48 == ai_16) break;
            li_48++;
         }
      }
      li_ret_28++;
   }
   if (l_icustom_40 != EMPTY_VALUE && l_icustom_40 != -1.0 && l_icustom_40 != 0.0) return (li_ret_28);
   return (-1);
}

int ZigZagLow(string a_symbol_0, int a_timeframe_8, int ai_12, int ai_16, int ai_20, int ai_24) {
   int li_ret_28 = ai_24;
   double l_ilow_32 = 0;
   double l_icustom_40 = 0;
   int li_48 = 1;
   while (true) {
      if (li_ret_28 >= ai_24 + ai_20) break;
      l_icustom_40 = iCustom(a_symbol_0, a_timeframe_8, "ZigZag", 12, ai_12, 3, 0, li_ret_28);
      l_ilow_32 = iLow(a_symbol_0, a_timeframe_8, li_ret_28);
      if (!(l_icustom_40 == 0.0 || l_icustom_40 == EMPTY_VALUE) && !(l_icustom_40 == -1.0)) {
         if (l_ilow_32 > 0.0 && l_icustom_40 > 0.0 && l_icustom_40 <= l_ilow_32) {
            if (li_48 == ai_16) break;
            li_48++;
         }
      }
      li_ret_28++;
   }
   if (l_icustom_40 != EMPTY_VALUE && l_icustom_40 != -1.0 && l_icustom_40 != 0.0) return (li_ret_28);
   return (-1);
}

void CalculateLowPivot(string as_0, int &ai_unused_8, int &ai_unused_12, double &ad_16, double &ad_24, int ai_32, int ai_36, int ai_40) {
   if (ShowFibs == 0 && (ad_24 != 0.0 && ad_16 != 0.0)) DrawUpFibs(as_0, ad_16, ad_24, ai_32, ai_36, ai_40);
}

void CalculateHighPivot(string as_0, int &ai_unused_8, int &ai_unused_12, double &ad_16, double &ad_24, int ai_32, int ai_36, int ai_40) {
   if (ShowFibs == 1 && (ad_24 != 0.0 && ad_16 != 0.0)) DrawDownFibs(as_0, ad_16, ad_24, ai_32, ai_36, ai_40);
}

void DrawUpFibs(string as_0, double ad_8, double ad_16, int ai_24, int ai_28, int ai_32) {
   double ld_36 = ad_16 + (ad_8 - ad_16) / 2.0;
   DrawLine(as_0 + "R161-" + Time[ai_32], ld_36, Time[ai_32] + 60 * (ai_28 * Period()), Time[ai_32], STYLE_DASHDOT, Green, ai_24);
   double ld_44 = ad_16 + (ad_8 - ad_16) / 2.0;
   DrawLine(as_0 + "R261-" + Time[ai_32], ld_44, Time[ai_32] + 60 * (ai_28 * Period()), Time[ai_32], STYLE_DASHDOT, DarkOliveGreen, ai_24);
   double ld_52 = ad_16 + 0.618 * (ad_8 - ad_16);
   DrawLine(as_0 + "R426-" + Time[ai_32], ld_52, Time[ai_32] + 60 * (ai_28 * Period()), Time[ai_32], STYLE_DASH, Black, ai_24);
   double ld_60 = ad_8 - 1.382 * (ad_8 - ad_16);
   DrawLine(as_0 + "R162-" + Time[ai_32], ld_60, Time[ai_32] + 60 * (ai_28 * Period()), Time[ai_32], STYLE_DASHDOT, Green, ai_24);
   double ld_68 = ad_8 - 1.618 * (ad_8 - ad_16);
   DrawLine(as_0 + "R262-" + Time[ai_32], ld_68, Time[ai_32] + 60 * (ai_28 * Period()), Time[ai_32], STYLE_DASHDOT, DarkOliveGreen, ai_24);
}

void DrawDownFibs(string as_0, double ad_8, double ad_16, int ai_24, int ai_28, int ai_32) {
   double ld_36 = ad_8 - (ad_8 - ad_16) / 2.0;
   DrawLine(as_0 + "S161-" + Time[ai_32], ld_36, Time[ai_32] + 60 * (ai_28 * Period()), Time[ai_32], STYLE_DASHDOT, Green, ai_24);
   double ld_44 = ad_8 - (ad_8 - ad_16) / 2.0;
   DrawLine(as_0 + "S261-" + Time[ai_32], ld_44, Time[ai_32] + 60 * (ai_28 * Period()), Time[ai_32], STYLE_DASHDOT, DarkOliveGreen, ai_24);
   double ld_52 = ad_8 - 0.618 * (ad_8 - ad_16);
   DrawLine(as_0 + "S426-" + Time[ai_32], ld_52, Time[ai_32] + 60 * (ai_28 * Period()), Time[ai_32], STYLE_DASH, Black, ai_24);
   double ld_60 = ad_16 + 1.382 * (ad_8 - ad_16);
   DrawLine(as_0 + "S162-" + Time[ai_32], ld_60, Time[ai_32] + 60 * (ai_28 * Period()), Time[ai_32], STYLE_DASHDOT, Green, ai_24);
   double ld_68 = ad_16 + 1.618 * (ad_8 - ad_16);
   DrawLine(as_0 + "S262-" + Time[ai_32], ld_68, Time[ai_32] + 60 * (ai_28 * Period()), Time[ai_32], STYLE_DASHDOT, DarkOliveGreen, ai_24);
}

void DrawLine(string a_name_0, double ad_8, int a_datetime_16, int a_datetime_20, int a_style_24, double a_color_28, int a_width_36) {
   if (ObjectFind(a_name_0) == -1) ObjectCreate(a_name_0, OBJ_TREND, 0, 0, 0);
   ObjectSet(a_name_0, OBJPROP_BACK, FALSE);
   ObjectSet(a_name_0, OBJPROP_PRICE1, ad_8);
   ObjectSet(a_name_0, OBJPROP_PRICE2, ad_8);
   ObjectSet(a_name_0, OBJPROP_COLOR, a_color_28);
   ObjectSet(a_name_0, OBJPROP_STYLE, a_style_24);
   ObjectSet(a_name_0, OBJPROP_WIDTH, a_width_36);
   if (a_datetime_16 == 0 && a_datetime_20 == 0) {
      ObjectSet(a_name_0, OBJPROP_RAY, TRUE);
      return;
   }
   ObjectSet(a_name_0, OBJPROP_TIME1, a_datetime_16);
   ObjectSet(a_name_0, OBJPROP_TIME2, a_datetime_20);
   ObjectSet(a_name_0, OBJPROP_RAY, FALSE);
}